
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega48PA
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 128 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega48PA
	#pragma AVRPART MEMORY PROG_FLASH 4096
	#pragma AVRPART MEMORY EEPROM 256
	#pragma AVRPART MEMORY INT_SRAM SIZE 767
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x02FF
	.EQU __DSTACK_SIZE=0x0080
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _N_Out=R4
	.DEF _N_Out_ULN=R3
	.DEF _Reg_Out=R5
	.DEF _count=R8
	.DEF _temp1=R7
	.DEF _temp2=R10
	.DEF _temp3=R9
	.DEF _j=R12
	.DEF _n=R11
	.DEF _temp_ULN=R14
	.DEF _temp_address=R13

;GPIOR0 INITIALIZATION VALUE
	.EQU __GPIOR0_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_comp_a
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0x1C1:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x06
	.DW  0x03
	.DW  _0x1C1*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x180

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.0 Professional
;Automatic Program Generator
; Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : TSOP
;Version : 1.0
;Date    : 06.05.2012
;Author  : Vychegzhanin Sergey
;Company : Home
;
;Chip type               : ATmega48PA
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 128
;*****************************************************/
;
;#include <mega48a.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif
;#include <delay.h>
;
;// Declare your global variables here
;
;#define ULN_1_7     PORTC.0   //   
;#define ULN_1_6     PORTC.1
;#define ULN_1_5     PORTC.2
;#define ULN_1_4     PORTC.3
;#define ULN_1_3     PORTC.4
;#define ULN_1_2     PORTC.5
;#define ULN_1_1     PORTD.0
;
;#define ULN_2_7     PORTB.7
;#define ULN_2_6     PORTD.5
;#define ULN_2_5     PORTD.6
;#define ULN_2_4     PORTD.7
;#define ULN_2_3     PORTB.0
;#define ULN_2_2     PORTB.1
;#define ULN_2_1     PORTB.2
;
;#define LED1        PORTD.1   //    
;#define LED2        PORTD.3   // LED1 - , LED2 - 
;
;#define B1          PIND.4    //     
;#define B2          PINB.6
;
;#define TSOP        PIND.2    //    TSOP
;
;#define DELAY_IMPULSE   40     //  
;#define DELAY_TRG       500    //   ""
;
;unsigned char N_Out = 0;        //      1 - 14
;unsigned char N_Out_ULN = 0;    //      1 - 14
;
;int Reg_Out = 0;    //   
;
;unsigned char count = 0;    //  
;
;bit Mode = 0;   // 0 -  
;                // 1 -   
;
;bit Correct = 0;    // 1 -   
;                    // 0 -   
;
;bit Permit = 0;     // 0 -  
;                    // 1 -  
;
;bit Success = 0;    // 0 -   
;                    // 1 -   
;
;bit Wait_Stop = 0;  // 0 -     
;                    // 1 -  
;
;bit Stop = 0;       // 0 - -  
;                    // 1 - - 
;
;bit Repeat = 0;     // 0 -    
;                    // 1 -   
;
;
;bit Execute = 0;    // 0 -   
;                    // 1 -    
;
;
;unsigned char temp1, temp2, temp3, j, n, temp_ULN;  //  
;
;int i;
;int T;  //       
;        //         TSOP'a
;
;eeprom unsigned char e_address[14];      //    
;eeprom unsigned char e_command[14];  //    
;eeprom unsigned char e_function[14];  //     
;
;unsigned char address[14];
;unsigned char command[14];
;unsigned char function[14]; // 0 - 
;                            // 1 - 
;                            // 2 -     (     )
;
;unsigned char temp_address;     //  
;unsigned char i_temp_address;   //   
;unsigned char temp_command;     //  
;unsigned char i_temp_command;   //   
;
;
;
;void ULN_Disable (void) //  0   
; 0000 006E {

	.CSEG
_ULN_Disable:
; 0000 006F 
; 0000 0070         ULN_1_1 = 0;
	CBI  0xB,0
; 0000 0071         ULN_1_2 = 0;
	CBI  0x8,5
; 0000 0072         ULN_1_3 = 0;
	CBI  0x8,4
; 0000 0073         ULN_1_4 = 0;
	CBI  0x8,3
; 0000 0074         ULN_1_5 = 0;
	CBI  0x8,2
; 0000 0075         ULN_1_6 = 0;
	CBI  0x8,1
; 0000 0076         ULN_1_7 = 0;
	CBI  0x8,0
; 0000 0077         ULN_2_1 = 0;
	CBI  0x5,2
; 0000 0078         ULN_2_2 = 0;
	CBI  0x5,1
; 0000 0079         ULN_2_3 = 0;
	CBI  0x5,0
; 0000 007A         ULN_2_4 = 0;
	CBI  0xB,7
; 0000 007B         ULN_2_5 = 0;
	CBI  0xB,6
; 0000 007C         ULN_2_6 = 0;
	CBI  0xB,5
; 0000 007D         ULN_2_7 = 0;
	CBI  0x5,7
; 0000 007E 
; 0000 007F }
	RET
;
;void Flash_light (unsigned char m)   //   n- 
; 0000 0082 {
_Flash_light:
; 0000 0083     if (m<=7)
;	m -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0x8)
	BRLO PC+2
	RJMP _0x1F
; 0000 0084         {
; 0000 0085           for (j=0; j<m; j++)
	CLR  R12
_0x21:
	LD   R30,Y
	CP   R12,R30
	BRLO PC+2
	RJMP _0x22
; 0000 0086             {
; 0000 0087                 LED2=1;
	RCALL SUBOPT_0x0
; 0000 0088                 delay_ms(300);
; 0000 0089                 LED2=0;
; 0000 008A                 delay_ms(300);
	RCALL SUBOPT_0x1
; 0000 008B             }
_0x20:
	INC  R12
	RJMP _0x21
_0x22:
; 0000 008C         }
; 0000 008D     else if (m<=14)
	RJMP _0x27
_0x1F:
	LD   R26,Y
	CPI  R26,LOW(0xF)
	BRLO PC+2
	RJMP _0x28
; 0000 008E         {
; 0000 008F             for (j=0; j<(m-7); j++)
	CLR  R12
_0x2A:
	RCALL SUBOPT_0x2
	SBIW R30,7
	RCALL SUBOPT_0x3
	BRLT PC+2
	RJMP _0x2B
; 0000 0090             {
; 0000 0091                 LED2=1;
	RCALL SUBOPT_0x4
; 0000 0092                 delay_ms(50);
; 0000 0093                 LED2=0;
; 0000 0094                 delay_ms(50);
	RCALL SUBOPT_0x5
; 0000 0095                 LED2=1;
	RCALL SUBOPT_0x4
; 0000 0096                 delay_ms(50);
; 0000 0097                 LED2=0;
; 0000 0098                 delay_ms(300);
	RCALL SUBOPT_0x1
; 0000 0099             }
_0x29:
	INC  R12
	RJMP _0x2A
_0x2B:
; 0000 009A         }
; 0000 009B         else
	RJMP _0x34
_0x28:
; 0000 009C 
; 0000 009D         {
; 0000 009E             for (j=0; j<(m-14); j++)
	CLR  R12
_0x36:
	RCALL SUBOPT_0x2
	SBIW R30,14
	RCALL SUBOPT_0x3
	BRLT PC+2
	RJMP _0x37
; 0000 009F             {
; 0000 00A0                 LED2=1;
	RCALL SUBOPT_0x4
; 0000 00A1                 delay_ms(50);
; 0000 00A2 
; 0000 00A3                 LED2=0;
; 0000 00A4                 delay_ms(50);
	RCALL SUBOPT_0x5
; 0000 00A5 
; 0000 00A6                 LED2=1;
	RCALL SUBOPT_0x0
; 0000 00A7                 delay_ms(300);
; 0000 00A8 
; 0000 00A9                 LED2=0;
; 0000 00AA                 delay_ms(50);
	RCALL SUBOPT_0x5
; 0000 00AB 
; 0000 00AC                 LED2=1;
	RCALL SUBOPT_0x4
; 0000 00AD                 delay_ms(50);
; 0000 00AE 
; 0000 00AF                 LED2=0;
; 0000 00B0                 delay_ms(300);
	RCALL SUBOPT_0x1
; 0000 00B1             }
_0x35:
	INC  R12
	RJMP _0x36
_0x37:
; 0000 00B2         }
_0x34:
_0x27:
; 0000 00B3 }
	ADIW R28,1
	RET
;
;
;interrupt [TIM2_COMPA] void timer2_comp_a(void)
; 0000 00B7 {
_timer2_comp_a:
	RCALL SUBOPT_0x6
; 0000 00B8   if (B1==0&B2==1) {temp1++;}     //    
	LDI  R26,0
	SBIC 0x9,4
	LDI  R26,1
	LDI  R30,LOW(0)
	RCALL __EQB12
	MOV  R0,R30
	RCALL SUBOPT_0x7
	LDI  R30,LOW(1)
	RCALL __EQB12
	AND  R30,R0
	BRNE PC+2
	RJMP _0x44
	INC  R7
; 0000 00B9  else {if (temp1>2) temp1--;}  //   ,   temp
	RJMP _0x45
_0x44:
	LDI  R30,LOW(2)
	CP   R30,R7
	BRLO PC+2
	RJMP _0x46
	DEC  R7
_0x46:
_0x45:
; 0000 00BA 
; 0000 00BB   if (B2==0&&B1==1) {temp2++;}     //    
	RCALL SUBOPT_0x7
	CPI  R26,LOW(0x0)
	BREQ PC+2
	RJMP _0x48
	SBIS 0x9,4
	RJMP _0x48
	RJMP _0x49
_0x48:
	RJMP _0x47
_0x49:
	INC  R10
; 0000 00BC  else {if (temp2>2) temp2--;}  //   ,   temp
	RJMP _0x4A
_0x47:
	LDI  R30,LOW(2)
	CP   R30,R10
	BRLO PC+2
	RJMP _0x4B
	DEC  R10
_0x4B:
_0x4A:
; 0000 00BD 
; 0000 00BE  if (B2==0&&B1==0) {temp3++;}     //    
	RCALL SUBOPT_0x7
	CPI  R26,LOW(0x0)
	BREQ PC+2
	RJMP _0x4D
	LDI  R26,0
	SBIC 0x9,4
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BREQ PC+2
	RJMP _0x4D
	RJMP _0x4E
_0x4D:
	RJMP _0x4C
_0x4E:
	INC  R9
; 0000 00BF  else {if (temp3>2) temp3--;}  //   ,   temp
	RJMP _0x4F
_0x4C:
	LDI  R30,LOW(2)
	CP   R30,R9
	BRLO PC+2
	RJMP _0x50
	DEC  R9
_0x50:
_0x4F:
; 0000 00C0 
; 0000 00C1 
; 0000 00C2 
; 0000 00C3  if (temp1>200&&temp2<10)   //   
	LDI  R30,LOW(200)
	CP   R30,R7
	BRLO PC+2
	RJMP _0x52
	LDI  R30,LOW(10)
	CP   R10,R30
	BRLO PC+2
	RJMP _0x52
	RJMP _0x53
_0x52:
	RJMP _0x51
_0x53:
; 0000 00C4     {
; 0000 00C5       Mode=~Mode;
	SBIS 0x1E,0
	RJMP _0x54
	CBI  0x1E,0
	RJMP _0x55
_0x54:
	SBI  0x1E,0
_0x55:
; 0000 00C6 
; 0000 00C7       if (Mode) LED1=1;
	SBIS 0x1E,0
	RJMP _0x56
	SBI  0xB,1
; 0000 00C8       else LED1=0;
	RJMP _0x59
_0x56:
	CBI  0xB,1
; 0000 00C9 
; 0000 00CA       N_Out=0;
_0x59:
	CLR  R4
; 0000 00CB 
; 0000 00CC       temp1=0;
	CLR  R7
; 0000 00CD 
; 0000 00CE       ULN_Disable(); //    0
	RCALL _ULN_Disable
; 0000 00CF 
; 0000 00D0      }
; 0000 00D1 
; 0000 00D2  if (temp2>100&&temp1<10)
_0x51:
	LDI  R30,LOW(100)
	CP   R30,R10
	BRLO PC+2
	RJMP _0x5D
	LDI  R30,LOW(10)
	CP   R7,R30
	BRLO PC+2
	RJMP _0x5D
	RJMP _0x5E
_0x5D:
	RJMP _0x5C
_0x5E:
; 0000 00D3     {
; 0000 00D4       if (Mode==1)  //    
	SBIS 0x1E,0
	RJMP _0x5F
; 0000 00D5          {
; 0000 00D6             if (N_Out<=13)
	LDI  R30,LOW(13)
	CP   R30,R4
	BRSH PC+2
	RJMP _0x60
; 0000 00D7                 {
; 0000 00D8                 N_Out++;
	INC  R4
; 0000 00D9 
; 0000 00DA                 Flash_light(N_Out);   //  N_out  LED2
	ST   -Y,R4
	RCALL _Flash_light
; 0000 00DB                 }
; 0000 00DC             else N_Out=0;
	RJMP _0x61
_0x60:
	CLR  R4
; 0000 00DD          }
_0x61:
; 0000 00DE 
; 0000 00DF 
; 0000 00E0       temp2=0;
_0x5F:
	CLR  R10
; 0000 00E1       }
; 0000 00E2 
; 0000 00E3   if (temp3>250)            //     B1  B2   EEPROM
_0x5C:
	LDI  R30,LOW(250)
	CP   R30,R9
	BRLO PC+2
	RJMP _0x62
; 0000 00E4     {
; 0000 00E5       for (n=0;n<14;n++)
	CLR  R11
_0x64:
	LDI  R30,LOW(14)
	CP   R11,R30
	BRLO PC+2
	RJMP _0x65
; 0000 00E6 
; 0000 00E7       {
; 0000 00E8         e_command[n]=0xFF;
	RCALL SUBOPT_0x8
	SUBI R26,LOW(-_e_command)
	SBCI R27,HIGH(-_e_command)
	LDI  R30,LOW(255)
	RCALL __EEPROMWRB
; 0000 00E9         e_address[n]=0xFF;
	RCALL SUBOPT_0x8
	SUBI R26,LOW(-_e_address)
	SBCI R27,HIGH(-_e_address)
	LDI  R30,LOW(255)
	RCALL __EEPROMWRB
; 0000 00EA         e_function[n]=0xFF;
	RCALL SUBOPT_0x8
	SUBI R26,LOW(-_e_function)
	SBCI R27,HIGH(-_e_function)
	LDI  R30,LOW(255)
	RCALL __EEPROMWRB
; 0000 00EB         command[n]=0xFF;
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
	LDI  R26,LOW(255)
	STD  Z+0,R26
; 0000 00EC         address[n]=0xFF;
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xB
	LDI  R26,LOW(255)
	STD  Z+0,R26
; 0000 00ED         function[n]=0xFF;
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xC
	LDI  R26,LOW(255)
	STD  Z+0,R26
; 0000 00EE 
; 0000 00EF         ULN_Disable(); //    0
	RCALL _ULN_Disable
; 0000 00F0       }
_0x63:
	INC  R11
	RJMP _0x64
_0x65:
; 0000 00F1 
; 0000 00F2       Flash_light(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _Flash_light
; 0000 00F3       temp3=0;
	CLR  R9
; 0000 00F4      }
; 0000 00F5 
; 0000 00F6 }
_0x62:
	RCALL SUBOPT_0xD
	RETI
;
;
;interrupt [EXT_INT0] void ext_int0_isr(void)  //       TSOP'
; 0000 00FA {
_ext_int0_isr:
	RCALL SUBOPT_0x6
; 0000 00FB  TCNT0=0x00;  //  
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 00FC  TCCR0B=0x02; //  
	LDI  R30,LOW(2)
	OUT  0x25,R30
; 0000 00FD 
; 0000 00FE  if ((T>3)&&(T<6)&&Permit)            //  0,768...1,536  -  0
	RCALL SUBOPT_0xE
	SBIW R26,4
	BRGE PC+2
	RJMP _0x67
	RCALL SUBOPT_0xE
	SBIW R26,6
	BRLT PC+2
	RJMP _0x67
	SBIS 0x1E,2
	RJMP _0x67
	RJMP _0x68
_0x67:
	RJMP _0x66
_0x68:
; 0000 00FF     {   count++;
	INC  R8
; 0000 0100 
; 0000 0101         if (count<=8) temp_address = temp_address<<1;                   //    
	LDI  R30,LOW(8)
	CP   R30,R8
	BRSH PC+2
	RJMP _0x69
	LSL  R13
; 0000 0102         if (count>=9 && count<=16) i_temp_address = i_temp_address<<1;  //    
_0x69:
	LDI  R30,LOW(9)
	CP   R8,R30
	BRSH PC+2
	RJMP _0x6B
	LDI  R30,LOW(16)
	CP   R30,R8
	BRSH PC+2
	RJMP _0x6B
	RJMP _0x6C
_0x6B:
	RJMP _0x6A
_0x6C:
	LDS  R30,_i_temp_address
	LSL  R30
	STS  _i_temp_address,R30
; 0000 0103         if (count>=17 && count<=24) temp_command = temp_command<<1;     //    
_0x6A:
	LDI  R30,LOW(17)
	CP   R8,R30
	BRSH PC+2
	RJMP _0x6E
	LDI  R30,LOW(24)
	CP   R30,R8
	BRSH PC+2
	RJMP _0x6E
	RJMP _0x6F
_0x6E:
	RJMP _0x6D
_0x6F:
	LDS  R30,_temp_command
	LSL  R30
	RCALL SUBOPT_0xF
; 0000 0104         if (count>=25 && count<=32) i_temp_command = i_temp_command<<1; //    
_0x6D:
	LDI  R30,LOW(25)
	CP   R8,R30
	BRSH PC+2
	RJMP _0x71
	RCALL SUBOPT_0x10
	BRSH PC+2
	RJMP _0x71
	RJMP _0x72
_0x71:
	RJMP _0x70
_0x72:
	LDS  R30,_i_temp_command
	LSL  R30
	STS  _i_temp_command,R30
; 0000 0105         if (count==32)
_0x70:
	RCALL SUBOPT_0x10
	BREQ PC+2
	RJMP _0x73
; 0000 0106             {
; 0000 0107              Permit=0;
	CBI  0x1E,2
; 0000 0108              Success=1;
	SBI  0x1E,3
; 0000 0109              }
; 0000 010A     }
_0x73:
; 0000 010B 
; 0000 010C  if ((T>7)&&(T<11)&&Permit)           //  1,782...2,816  -  1
_0x66:
	RCALL SUBOPT_0xE
	SBIW R26,8
	BRGE PC+2
	RJMP _0x79
	RCALL SUBOPT_0xE
	SBIW R26,11
	BRLT PC+2
	RJMP _0x79
	SBIS 0x1E,2
	RJMP _0x79
	RJMP _0x7A
_0x79:
	RJMP _0x78
_0x7A:
; 0000 010D     {   count++;
	INC  R8
; 0000 010E 
; 0000 010F         if (count<=8) temp_address = (temp_address<<1) + 1;                     //    
	LDI  R30,LOW(8)
	CP   R30,R8
	BRSH PC+2
	RJMP _0x7B
	MOV  R30,R13
	RCALL SUBOPT_0x11
	MOV  R13,R30
; 0000 0110         if (count>=9 && count<=16) i_temp_address = (i_temp_address<<1) + 1;    //    
_0x7B:
	LDI  R30,LOW(9)
	CP   R8,R30
	BRSH PC+2
	RJMP _0x7D
	LDI  R30,LOW(16)
	CP   R30,R8
	BRSH PC+2
	RJMP _0x7D
	RJMP _0x7E
_0x7D:
	RJMP _0x7C
_0x7E:
	LDS  R30,_i_temp_address
	RCALL SUBOPT_0x11
	STS  _i_temp_address,R30
; 0000 0111         if (count>=17 && count<=24) temp_command = (temp_command<<1) + 1;       //    
_0x7C:
	LDI  R30,LOW(17)
	CP   R8,R30
	BRSH PC+2
	RJMP _0x80
	LDI  R30,LOW(24)
	CP   R30,R8
	BRSH PC+2
	RJMP _0x80
	RJMP _0x81
_0x80:
	RJMP _0x7F
_0x81:
	LDS  R30,_temp_command
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0xF
; 0000 0112         if (count>=25 && count<=32) i_temp_command = (i_temp_command<<1) + 1;   //    
_0x7F:
	LDI  R30,LOW(25)
	CP   R8,R30
	BRSH PC+2
	RJMP _0x83
	RCALL SUBOPT_0x10
	BRSH PC+2
	RJMP _0x83
	RJMP _0x84
_0x83:
	RJMP _0x82
_0x84:
	LDS  R30,_i_temp_command
	RCALL SUBOPT_0x11
	STS  _i_temp_command,R30
; 0000 0113         if (count==32)
_0x82:
	RCALL SUBOPT_0x10
	BREQ PC+2
	RJMP _0x85
; 0000 0114             {
; 0000 0115              Permit=0;
	CBI  0x1E,2
; 0000 0116              Success=1;
	SBI  0x1E,3
; 0000 0117              }
; 0000 0118     }
_0x85:
; 0000 0119 
; 0000 011A  if ((T>35)&&(T<47)&&Wait_Stop)       //  8,96...12,032  -   stop
_0x78:
	RCALL SUBOPT_0xE
	SBIW R26,36
	BRGE PC+2
	RJMP _0x8B
	RCALL SUBOPT_0xE
	SBIW R26,47
	BRLT PC+2
	RJMP _0x8B
	SBIS 0x1E,4
	RJMP _0x8B
	RJMP _0x8C
_0x8B:
	RJMP _0x8A
_0x8C:
; 0000 011B     {
; 0000 011C       Stop = 1;
	SBI  0x1E,5
; 0000 011D       }
; 0000 011E 
; 0000 011F  if ((T>50)&&(T<55))                  //  12,8...14,08  -   start
_0x8A:
	RCALL SUBOPT_0xE
	SBIW R26,51
	BRGE PC+2
	RJMP _0x90
	RCALL SUBOPT_0xE
	SBIW R26,55
	BRLT PC+2
	RJMP _0x90
	RJMP _0x91
_0x90:
	RJMP _0x8F
_0x91:
; 0000 0120     {
; 0000 0121       temp_address = 0;
	CLR  R13
; 0000 0122       i_temp_address = 0;
	LDI  R30,LOW(0)
	STS  _i_temp_address,R30
; 0000 0123       temp_command = 0;
	RCALL SUBOPT_0xF
; 0000 0124       i_temp_command = 0;
	LDI  R30,LOW(0)
	STS  _i_temp_command,R30
; 0000 0125 
; 0000 0126       count=0;
	CLR  R8
; 0000 0127       Permit = 1;
	SBI  0x1E,2
; 0000 0128       Success = 0;
	RCALL SUBOPT_0x12
; 0000 0129       Wait_Stop = 0;
; 0000 012A       Stop = 0;
; 0000 012B       Repeat = 0;
; 0000 012C       Correct = 0;
; 0000 012D 
; 0000 012E     }
; 0000 012F 
; 0000 0130  if ((T>150)&&(T<160)&&Success)       //  38...40,96  -  wait_stop
_0x8F:
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x97)
	LDI  R30,HIGH(0x97)
	CPC  R27,R30
	BRGE PC+2
	RJMP _0x9F
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0xA0)
	LDI  R30,HIGH(0xA0)
	CPC  R27,R30
	BRLT PC+2
	RJMP _0x9F
	SBIS 0x1E,3
	RJMP _0x9F
	RJMP _0xA0
_0x9F:
	RJMP _0x9E
_0xA0:
; 0000 0131     {
; 0000 0132        Wait_Stop = 1;
	SBI  0x1E,4
; 0000 0133     }
; 0000 0134 
; 0000 0135  if ((T>350)&&(T<420)&&Correct)       //  89,6...107,52  -  repeat
_0x9E:
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x15F)
	LDI  R30,HIGH(0x15F)
	CPC  R27,R30
	BRGE PC+2
	RJMP _0xA4
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x1A4)
	LDI  R30,HIGH(0x1A4)
	CPC  R27,R30
	BRLT PC+2
	RJMP _0xA4
	SBIS 0x1E,1
	RJMP _0xA4
	RJMP _0xA5
_0xA4:
	RJMP _0xA3
_0xA5:
; 0000 0136     {
; 0000 0137         Repeat = 1;
	SBI  0x1E,6
; 0000 0138 
; 0000 0139 
; 0000 013A     }
; 0000 013B 
; 0000 013C   T=0;
_0xA3:
	RCALL SUBOPT_0x13
; 0000 013D 
; 0000 013E   if ((Success == 1)&&(temp_address + i_temp_address == 0xff)&&(temp_command + i_temp_command == 0xff))
	SBIS 0x1E,3
	RJMP _0xA9
	MOV  R26,R13
	CLR  R27
	LDS  R30,_i_temp_address
	RCALL SUBOPT_0x14
	BREQ PC+2
	RJMP _0xA9
	LDS  R26,_temp_command
	CLR  R27
	LDS  R30,_i_temp_command
	RCALL SUBOPT_0x14
	BREQ PC+2
	RJMP _0xA9
	RJMP _0xAA
_0xA9:
	RJMP _0xA8
_0xAA:
; 0000 013F 
; 0000 0140   //    
; 0000 0141   //    
; 0000 0142     {
; 0000 0143         Correct = 1;
	SBI  0x1E,1
; 0000 0144     }
; 0000 0145 
; 0000 0146 
; 0000 0147   if ((Mode==1)&&(Stop==1)&&(Correct==1)&&(Success==1))  //     
_0xA8:
	SBIS 0x1E,0
	RJMP _0xAE
	SBIS 0x1E,5
	RJMP _0xAE
	SBIS 0x1E,1
	RJMP _0xAE
	SBIS 0x1E,3
	RJMP _0xAE
	RJMP _0xAF
_0xAE:
	RJMP _0xAD
_0xAF:
; 0000 0148     {
; 0000 0149         TCCR0B=0x00;
	LDI  R30,LOW(0)
	OUT  0x25,R30
; 0000 014A 
; 0000 014B         if (N_Out>0)
	CP   R30,R4
	BRLO PC+2
	RJMP _0xB0
; 0000 014C         {
; 0000 014D         address[N_Out-1] = temp_address;
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0xB
	ST   Z,R13
; 0000 014E         command[N_Out-1]= temp_command;
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0xA
	LDS  R26,_temp_command
	STD  Z+0,R26
; 0000 014F 
; 0000 0150         e_address[N_Out-1] = address[N_Out-1];
	RCALL SUBOPT_0x15
	SUBI R30,LOW(-_e_address)
	SBCI R31,HIGH(-_e_address)
	MOVW R26,R30
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0xB
	LD   R30,Z
	RCALL __EEPROMWRB
; 0000 0151         e_command[N_Out-1]= command[N_Out-1];
	RCALL SUBOPT_0x15
	SUBI R30,LOW(-_e_command)
	SBCI R31,HIGH(-_e_command)
	MOVW R26,R30
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0xA
	LD   R30,Z
	RCALL __EEPROMWRB
; 0000 0152 
; 0000 0153         if (function[N_Out-1]<3) function[N_Out-1] += 1;  //     EEPROM - 0xFF
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x3)
	BRLO PC+2
	RJMP _0xB1
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0xC
	MOVW R26,R30
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
; 0000 0154         else function[N_Out-1] = 0 ;                      //      0x00
	RJMP _0xB2
_0xB1:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0xC
	LDI  R26,LOW(0)
	STD  Z+0,R26
; 0000 0155 
; 0000 0156         e_function[N_Out-1]= function[N_Out-1];
_0xB2:
	RCALL SUBOPT_0x15
	SUBI R30,LOW(-_e_function)
	SBCI R31,HIGH(-_e_function)
	MOVW R26,R30
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x17
	RCALL __EEPROMWRB
; 0000 0157 
; 0000 0158         }
; 0000 0159 
; 0000 015A         Flash_light(15);
_0xB0:
	LDI  R30,LOW(15)
	ST   -Y,R30
	RCALL _Flash_light
; 0000 015B 
; 0000 015C         Permit = 0;
	CBI  0x1E,2
; 0000 015D         Success = 0;
	RCALL SUBOPT_0x12
; 0000 015E         Wait_Stop = 0;
; 0000 015F         Stop = 0;
; 0000 0160         Repeat = 0;
; 0000 0161         Correct = 0;
; 0000 0162 
; 0000 0163     }
; 0000 0164 
; 0000 0165   if ((Mode==0)&&(Success==1||Repeat==1)&&(Stop==1)&&(Correct==1))  //     
_0xAD:
	LDI  R26,0
	SBIC 0x1E,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BREQ PC+2
	RJMP _0xC0
	SBIC 0x1E,3
	RJMP _0xC1
	SBIC 0x1E,6
	RJMP _0xC1
	RJMP _0xC0
_0xC1:
	SBIS 0x1E,5
	RJMP _0xC0
	SBIS 0x1E,1
	RJMP _0xC0
	RJMP _0xC3
_0xC0:
	RJMP _0xBF
_0xC3:
; 0000 0166     {    TCCR0B=0x00;
	LDI  R30,LOW(0)
	OUT  0x25,R30
; 0000 0167 
; 0000 0168                 for (n=0; n<14; n++)       //     
	CLR  R11
_0xC5:
	LDI  R30,LOW(14)
	CP   R11,R30
	BRLO PC+2
	RJMP _0xC6
; 0000 0169                     {
; 0000 016A                       if ((temp_command == command[n])&&(temp_address == address[n]))
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
	LD   R30,Z
	LDS  R26,_temp_command
	CP   R30,R26
	BREQ PC+2
	RJMP _0xC8
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xB
	LD   R30,Z
	CP   R30,R13
	BREQ PC+2
	RJMP _0xC8
	RJMP _0xC9
_0xC8:
	RJMP _0xC7
_0xC9:
; 0000 016B                             {
; 0000 016C                              N_Out_ULN = n;
	MOV  R3,R11
; 0000 016D                              Execute = 1;
	SBI  0x1E,7
; 0000 016E                              n=14;
	LDI  R30,LOW(14)
	MOV  R11,R30
; 0000 016F                             }
; 0000 0170                     }
_0xC7:
_0xC4:
	INC  R11
	RJMP _0xC5
_0xC6:
; 0000 0171 
; 0000 0172          Success = 0;
	CBI  0x1E,3
; 0000 0173          Repeat = 0;
	CBI  0x1E,6
; 0000 0174     }
; 0000 0175 }
_0xBF:
	RCALL SUBOPT_0xD
	RETI
;
;
; interrupt [TIM0_OVF] void timer0_ovf_isr(void)    //   256 
; 0000 0179 {
_timer0_ovf_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 017A TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 017B if (T>450)
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x1C3)
	LDI  R30,HIGH(0x1C3)
	CPC  R27,R30
	BRGE PC+2
	RJMP _0xD0
; 0000 017C     {
; 0000 017D         count = 0; //   ,   -
	CLR  R8
; 0000 017E         Permit = 0;
	CBI  0x1E,2
; 0000 017F         Success = 0;
	CBI  0x1E,3
; 0000 0180         Correct = 0;
	CBI  0x1E,1
; 0000 0181         Repeat = 0;
	CBI  0x1E,6
; 0000 0182         Stop = 0;
	CBI  0x1E,5
; 0000 0183         T = 0;
	RCALL SUBOPT_0x13
; 0000 0184         temp_command = 0x00;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xF
; 0000 0185         temp_address = 0x00;
	CLR  R13
; 0000 0186         TCCR0B=0x00;
	LDI  R30,LOW(0)
	OUT  0x25,R30
; 0000 0187         }
; 0000 0188 else T++;
	RJMP _0xDB
_0xD0:
	LDI  R26,LOW(_T)
	LDI  R27,HIGH(_T)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 0189 }
_0xDB:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;
;void main(void)
; 0000 018C {
_main:
; 0000 018D 
; 0000 018E // Crystal Oscillator division factor: 1
; 0000 018F #pragma optsize-
; 0000 0190 CLKPR=0x80;
	LDI  R30,LOW(128)
	STS  97,R30
; 0000 0191 CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
; 0000 0192 #ifdef _OPTIMIZE_SIZE_
; 0000 0193 #pragma optsize+
; 0000 0194 #endif
; 0000 0195 
; 0000 0196 //  
; 0000 0197 {
; 0000 0198 PORTB=0x40;
	LDI  R30,LOW(64)
	OUT  0x5,R30
; 0000 0199 DDRB=0x87;
	LDI  R30,LOW(135)
	OUT  0x4,R30
; 0000 019A PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x8,R30
; 0000 019B DDRC=0x3F;
	LDI  R30,LOW(63)
	OUT  0x7,R30
; 0000 019C PORTD=0x14;
	LDI  R30,LOW(20)
	OUT  0xB,R30
; 0000 019D DDRD=0xEB;
	LDI  R30,LOW(235)
	OUT  0xA,R30
; 0000 019E 
; 0000 019F // Timer/Counter 0 initialization
; 0000 01A0 TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 01A1 TCCR0B=0x02;
	LDI  R30,LOW(2)
	OUT  0x25,R30
; 0000 01A2 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 01A3 OCR0A=0x00;
	OUT  0x27,R30
; 0000 01A4 OCR0B=0x00;
	OUT  0x28,R30
; 0000 01A5 
; 0000 01A6 // Timer/Counter 1 initialization
; 0000 01A7 TCCR1A=0x00;
	STS  128,R30
; 0000 01A8 TCCR1B=0x00;
	STS  129,R30
; 0000 01A9 //TCCR1B=0x04;
; 0000 01AA TCNT1H=0x00;
	STS  133,R30
; 0000 01AB TCNT1L=0x00;
	STS  132,R30
; 0000 01AC ICR1H=0x00;
	STS  135,R30
; 0000 01AD ICR1L=0x00;
	STS  134,R30
; 0000 01AE OCR1AH=0x00;
	STS  137,R30
; 0000 01AF OCR1AL=0x00;
	STS  136,R30
; 0000 01B0 OCR1BH=0x00;
	STS  139,R30
; 0000 01B1 OCR1BL=0x00;
	STS  138,R30
; 0000 01B2 
; 0000 01B3 // Timer/Counter 2 initialization
; 0000 01B4 ASSR=0x00;
	STS  182,R30
; 0000 01B5 TCCR2A=0x82;
	LDI  R30,LOW(130)
	STS  176,R30
; 0000 01B6 TCCR2B=0x05;
	LDI  R30,LOW(5)
	STS  177,R30
; 0000 01B7 TCNT2=0x00;
	LDI  R30,LOW(0)
	STS  178,R30
; 0000 01B8 OCR2A=0xFF;
	LDI  R30,LOW(255)
	STS  179,R30
; 0000 01B9 OCR2B=0x00;
	LDI  R30,LOW(0)
	STS  180,R30
; 0000 01BA 
; 0000 01BB // External Interrupt(s) initialization
; 0000 01BC EICRA=0x02;
	LDI  R30,LOW(2)
	STS  105,R30
; 0000 01BD EIMSK=0x01;
	LDI  R30,LOW(1)
	OUT  0x1D,R30
; 0000 01BE EIFR=0x01;
	OUT  0x1C,R30
; 0000 01BF PCICR=0x00;
	LDI  R30,LOW(0)
	STS  104,R30
; 0000 01C0 
; 0000 01C1 // Timer/Counter 0 Interrupt(s) initialization
; 0000 01C2 TIMSK0=0x01;
	LDI  R30,LOW(1)
	STS  110,R30
; 0000 01C3 
; 0000 01C4 // Timer/Counter 1 Interrupt(s) initialization
; 0000 01C5 TIMSK1=0x00;
	LDI  R30,LOW(0)
	STS  111,R30
; 0000 01C6 
; 0000 01C7 // Timer/Counter 2 Interrupt(s) initialization
; 0000 01C8 TIMSK2=0x02;
	LDI  R30,LOW(2)
	STS  112,R30
; 0000 01C9 TIFR0=0x02;
	OUT  0x15,R30
; 0000 01CA TIFR2=0x02;
	OUT  0x17,R30
; 0000 01CB 
; 0000 01CC // USART initialization
; 0000 01CD // USART disabled
; 0000 01CE UCSR0B=0x00;
	LDI  R30,LOW(0)
	STS  193,R30
; 0000 01CF 
; 0000 01D0 // Analog Comparator initialization
; 0000 01D1 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
; 0000 01D2 ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
; 0000 01D3 DIDR1=0x00;
	STS  127,R30
; 0000 01D4 
; 0000 01D5 // ADC initialization
; 0000 01D6 ADCSRA=0x00;
	STS  122,R30
; 0000 01D7 
; 0000 01D8 // SPI initialization
; 0000 01D9 // SPI disabled
; 0000 01DA SPCR=0x00;
	OUT  0x2C,R30
; 0000 01DB 
; 0000 01DC // TWI initialization
; 0000 01DD // TWI disabled
; 0000 01DE TWCR=0x00;
	STS  188,R30
; 0000 01DF  }
; 0000 01E0 
; 0000 01E1 
; 0000 01E2 
; 0000 01E3 for (n=0;n<14;n++)      //     EEPROM'
	CLR  R11
_0xDD:
	LDI  R30,LOW(14)
	CP   R11,R30
	BRLO PC+2
	RJMP _0xDE
; 0000 01E4 
; 0000 01E5 {
; 0000 01E6   address[n] = e_address[n];
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xB
	MOVW R0,R30
	RCALL SUBOPT_0x8
	SUBI R26,LOW(-_e_address)
	SBCI R27,HIGH(-_e_address)
	RCALL SUBOPT_0x18
; 0000 01E7   command[n] = e_command[n];
	RCALL SUBOPT_0xA
	MOVW R0,R30
	RCALL SUBOPT_0x8
	SUBI R26,LOW(-_e_command)
	SBCI R27,HIGH(-_e_command)
	RCALL SUBOPT_0x18
; 0000 01E8   function[n] = e_function[n];
	RCALL SUBOPT_0xC
	MOVW R0,R30
	RCALL SUBOPT_0x8
	SUBI R26,LOW(-_e_function)
	SBCI R27,HIGH(-_e_function)
	RCALL __EEPROMRDB
	MOVW R26,R0
	ST   X,R30
; 0000 01E9 }
_0xDC:
	INC  R11
	RJMP _0xDD
_0xDE:
; 0000 01EA 
; 0000 01EB 
; 0000 01EC #asm ("sei")
	sei
; 0000 01ED 
; 0000 01EE 
; 0000 01EF while (1)        //      
_0xDF:
; 0000 01F0       {
; 0000 01F1         if (Execute==1)     //      
	SBIS 0x1E,7
	RJMP _0xE2
; 0000 01F2                             //    
; 0000 01F3         {
; 0000 01F4            Reg_Out=0;
	CLR  R5
	CLR  R6
; 0000 01F5            temp_ULN = 0x00;
	CLR  R14
; 0000 01F6 
; 0000 01F7 
; 0000 01F8            switch (N_Out_ULN)
	RCALL SUBOPT_0x19
; 0000 01F9            {
; 0000 01FA 
; 0000 01FB             case 0:  /////////////////////////
	SBIW R30,0
	BREQ PC+2
	RJMP _0xE6
; 0000 01FC            {
; 0000 01FD                 if (function[N_Out_ULN]==0)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x17
	CPI  R30,0
	BREQ PC+2
	RJMP _0xE7
; 0000 01FE                     {
; 0000 01FF                      ULN_1_1 = 1;
	SBI  0xB,0
; 0000 0200                      delay_ms(DELAY_IMPULSE);
	RCALL SUBOPT_0x1A
; 0000 0201                      ULN_1_1 = 0;
	CBI  0xB,0
; 0000 0202                      }
; 0000 0203                 if (function[N_Out_ULN]==1)
_0xE7:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0xEC
; 0000 0204                     {
; 0000 0205                      ULN_1_1 = ~ULN_1_1;
	SBIS 0xB,0
	RJMP _0xED
	CBI  0xB,0
	RJMP _0xEE
_0xED:
	SBI  0xB,0
_0xEE:
; 0000 0206                      delay_ms(DELAY_TRG);
	RCALL SUBOPT_0x1B
; 0000 0207                     }
; 0000 0208 
; 0000 0209            }
_0xEC:
; 0000 020A            break;
	RJMP _0xE5
; 0000 020B 
; 0000 020C            case 1:   /////////////////////////
_0xE6:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xEF
; 0000 020D            {
; 0000 020E                 if (function[N_Out_ULN]==0)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x17
	CPI  R30,0
	BREQ PC+2
	RJMP _0xF0
; 0000 020F                     {
; 0000 0210                      ULN_1_2 = 1;
	SBI  0x8,5
; 0000 0211                      delay_ms(DELAY_IMPULSE);
	RCALL SUBOPT_0x1A
; 0000 0212                      ULN_1_2 = 0;
	CBI  0x8,5
; 0000 0213                      }
; 0000 0214                 if (function[N_Out_ULN]==1)
_0xF0:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0xF5
; 0000 0215                     {
; 0000 0216                      ULN_1_2 = ~ULN_1_2;
	SBIS 0x8,5
	RJMP _0xF6
	CBI  0x8,5
	RJMP _0xF7
_0xF6:
	SBI  0x8,5
_0xF7:
; 0000 0217                      delay_ms(DELAY_TRG);
	RCALL SUBOPT_0x1B
; 0000 0218                     }
; 0000 0219 
; 0000 021A            }
_0xF5:
; 0000 021B            break;
	RJMP _0xE5
; 0000 021C 
; 0000 021D            case 2:  /////////////////////////
_0xEF:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xF8
; 0000 021E            {
; 0000 021F                 if (function[N_Out_ULN]==0)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x17
	CPI  R30,0
	BREQ PC+2
	RJMP _0xF9
; 0000 0220                     {
; 0000 0221                      ULN_1_3 = 1;
	SBI  0x8,4
; 0000 0222                      delay_ms(DELAY_IMPULSE);
	RCALL SUBOPT_0x1A
; 0000 0223                      ULN_1_3 = 0;
	CBI  0x8,4
; 0000 0224                      }
; 0000 0225                 if (function[N_Out_ULN]==1)
_0xF9:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0xFE
; 0000 0226                     {
; 0000 0227                      ULN_1_3 = ~ULN_1_3;
	SBIS 0x8,4
	RJMP _0xFF
	CBI  0x8,4
	RJMP _0x100
_0xFF:
	SBI  0x8,4
_0x100:
; 0000 0228                      delay_ms(DELAY_TRG);
	RCALL SUBOPT_0x1B
; 0000 0229                     }
; 0000 022A 
; 0000 022B            }
_0xFE:
; 0000 022C            break;
	RJMP _0xE5
; 0000 022D 
; 0000 022E            case 3:  /////////////////////////
_0xF8:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x101
; 0000 022F            {
; 0000 0230                 if (function[N_Out_ULN]==0)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x17
	CPI  R30,0
	BREQ PC+2
	RJMP _0x102
; 0000 0231                     {
; 0000 0232                      ULN_1_4 = 1;
	SBI  0x8,3
; 0000 0233                      delay_ms(DELAY_IMPULSE);
	RCALL SUBOPT_0x1A
; 0000 0234                      ULN_1_4 = 0;
	CBI  0x8,3
; 0000 0235                      }
; 0000 0236                 if (function[N_Out_ULN]==1)
_0x102:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x107
; 0000 0237                     {
; 0000 0238                      ULN_1_4 = ~ULN_1_4;
	SBIS 0x8,3
	RJMP _0x108
	CBI  0x8,3
	RJMP _0x109
_0x108:
	SBI  0x8,3
_0x109:
; 0000 0239                      delay_ms(DELAY_TRG);
	RCALL SUBOPT_0x1B
; 0000 023A                     }
; 0000 023B 
; 0000 023C            }
_0x107:
; 0000 023D            break;
	RJMP _0xE5
; 0000 023E 
; 0000 023F            case 4: /////////////////////////
_0x101:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x10A
; 0000 0240            {
; 0000 0241                 if (function[N_Out_ULN]==0)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x17
	CPI  R30,0
	BREQ PC+2
	RJMP _0x10B
; 0000 0242                     {
; 0000 0243                      ULN_1_5 = 1;
	SBI  0x8,2
; 0000 0244                      delay_ms(DELAY_IMPULSE);
	RCALL SUBOPT_0x1A
; 0000 0245                      ULN_1_5 = 0;
	CBI  0x8,2
; 0000 0246                      }
; 0000 0247                 if (function[N_Out_ULN]==1)
_0x10B:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x110
; 0000 0248                     {
; 0000 0249                      ULN_1_5 = ~ULN_1_5;
	SBIS 0x8,2
	RJMP _0x111
	CBI  0x8,2
	RJMP _0x112
_0x111:
	SBI  0x8,2
_0x112:
; 0000 024A                      delay_ms(DELAY_TRG);
	RCALL SUBOPT_0x1B
; 0000 024B                     }
; 0000 024C 
; 0000 024D            }
_0x110:
; 0000 024E            break;
	RJMP _0xE5
; 0000 024F 
; 0000 0250            case 5:  /////////////////////////
_0x10A:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x113
; 0000 0251            {
; 0000 0252                 if (function[N_Out_ULN]==0)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x17
	CPI  R30,0
	BREQ PC+2
	RJMP _0x114
; 0000 0253                     {
; 0000 0254                      ULN_1_6 = 1;
	SBI  0x8,1
; 0000 0255                      delay_ms(DELAY_IMPULSE);
	RCALL SUBOPT_0x1A
; 0000 0256                      ULN_1_6 = 0;
	CBI  0x8,1
; 0000 0257                      }
; 0000 0258                 if (function[N_Out_ULN]==1)
_0x114:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x119
; 0000 0259                     {
; 0000 025A                      ULN_1_6 = ~ULN_1_6;
	SBIS 0x8,1
	RJMP _0x11A
	CBI  0x8,1
	RJMP _0x11B
_0x11A:
	SBI  0x8,1
_0x11B:
; 0000 025B                      delay_ms(DELAY_TRG);
	RCALL SUBOPT_0x1B
; 0000 025C                     }
; 0000 025D 
; 0000 025E 
; 0000 025F            }
_0x119:
; 0000 0260            break;
	RJMP _0xE5
; 0000 0261 
; 0000 0262            case 6:  /////////////////////////
_0x113:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x11C
; 0000 0263            {
; 0000 0264                 if (function[N_Out_ULN]==0)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x17
	CPI  R30,0
	BREQ PC+2
	RJMP _0x11D
; 0000 0265                     {
; 0000 0266                      ULN_1_7 = 1;
	SBI  0x8,0
; 0000 0267                      delay_ms(DELAY_IMPULSE);
	RCALL SUBOPT_0x1A
; 0000 0268                      ULN_1_7 = 0;
	CBI  0x8,0
; 0000 0269                      }
; 0000 026A                 if (function[N_Out_ULN]==1)
_0x11D:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x122
; 0000 026B                     {
; 0000 026C                      ULN_1_7 = ~ULN_1_7;
	SBIS 0x8,0
	RJMP _0x123
	CBI  0x8,0
	RJMP _0x124
_0x123:
	SBI  0x8,0
_0x124:
; 0000 026D                      delay_ms(DELAY_TRG);
	RCALL SUBOPT_0x1B
; 0000 026E                     }
; 0000 026F 
; 0000 0270 
; 0000 0271            }
_0x122:
; 0000 0272            break;
	RJMP _0xE5
; 0000 0273 
; 0000 0274            case 7: /////////////////////////
_0x11C:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x125
; 0000 0275            {
; 0000 0276                 if (function[N_Out_ULN]==0)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x17
	CPI  R30,0
	BREQ PC+2
	RJMP _0x126
; 0000 0277                     {
; 0000 0278                      ULN_2_1 = 1;
	SBI  0x5,2
; 0000 0279                      delay_ms(DELAY_IMPULSE);
	RCALL SUBOPT_0x1A
; 0000 027A                      ULN_2_1 = 0;
	CBI  0x5,2
; 0000 027B                      }
; 0000 027C                 if (function[N_Out_ULN]==1)
_0x126:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x12B
; 0000 027D                     {
; 0000 027E                      ULN_2_1 = ~ULN_2_1;
	SBIS 0x5,2
	RJMP _0x12C
	CBI  0x5,2
	RJMP _0x12D
_0x12C:
	SBI  0x5,2
_0x12D:
; 0000 027F                      delay_ms(DELAY_TRG);
	RCALL SUBOPT_0x1B
; 0000 0280                     }
; 0000 0281 
; 0000 0282 
; 0000 0283            }
_0x12B:
; 0000 0284            break;
	RJMP _0xE5
; 0000 0285 
; 0000 0286            case 8: /////////////////////////
_0x125:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x12E
; 0000 0287            {
; 0000 0288                 if (function[N_Out_ULN]==0)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x17
	CPI  R30,0
	BREQ PC+2
	RJMP _0x12F
; 0000 0289                     {
; 0000 028A                      ULN_2_2 = 1;
	SBI  0x5,1
; 0000 028B                      delay_ms(DELAY_IMPULSE);
	RCALL SUBOPT_0x1A
; 0000 028C                      ULN_2_2 = 0;
	CBI  0x5,1
; 0000 028D                      }
; 0000 028E                 if (function[N_Out_ULN]==1)
_0x12F:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x134
; 0000 028F                     {
; 0000 0290                      ULN_2_2 = ~ULN_2_2;
	SBIS 0x5,1
	RJMP _0x135
	CBI  0x5,1
	RJMP _0x136
_0x135:
	SBI  0x5,1
_0x136:
; 0000 0291                      delay_ms(DELAY_TRG);
	RCALL SUBOPT_0x1B
; 0000 0292                     }
; 0000 0293 
; 0000 0294 
; 0000 0295            }
_0x134:
; 0000 0296            break;
	RJMP _0xE5
; 0000 0297 
; 0000 0298            case 9: /////////////////////////
_0x12E:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x137
; 0000 0299            {
; 0000 029A                 if (function[N_Out_ULN]==0)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x17
	CPI  R30,0
	BREQ PC+2
	RJMP _0x138
; 0000 029B                     {
; 0000 029C                      ULN_2_3 = 1;
	SBI  0x5,0
; 0000 029D                      delay_ms(DELAY_IMPULSE);
	RCALL SUBOPT_0x1A
; 0000 029E                      ULN_2_3 = 0;
	CBI  0x5,0
; 0000 029F                      }
; 0000 02A0                 if (function[N_Out_ULN]==1)
_0x138:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x13D
; 0000 02A1                     {
; 0000 02A2                      ULN_2_3 = ~ULN_2_3;
	SBIS 0x5,0
	RJMP _0x13E
	CBI  0x5,0
	RJMP _0x13F
_0x13E:
	SBI  0x5,0
_0x13F:
; 0000 02A3                      delay_ms(DELAY_TRG);
	RCALL SUBOPT_0x1B
; 0000 02A4                     }
; 0000 02A5 
; 0000 02A6 
; 0000 02A7            }
_0x13D:
; 0000 02A8            break;
	RJMP _0xE5
; 0000 02A9 
; 0000 02AA            case 10: /////////////////////////
_0x137:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x140
; 0000 02AB            {
; 0000 02AC                 if (function[N_Out_ULN]==0)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x17
	CPI  R30,0
	BREQ PC+2
	RJMP _0x141
; 0000 02AD                     {
; 0000 02AE                      ULN_2_4 = 1;
	SBI  0xB,7
; 0000 02AF                      delay_ms(DELAY_IMPULSE);
	RCALL SUBOPT_0x1A
; 0000 02B0                      ULN_2_4 = 0;
	CBI  0xB,7
; 0000 02B1                      }
; 0000 02B2                 if (function[N_Out_ULN]==1)
_0x141:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x146
; 0000 02B3                     {
; 0000 02B4                      ULN_2_4 = ~ULN_2_4;
	SBIS 0xB,7
	RJMP _0x147
	CBI  0xB,7
	RJMP _0x148
_0x147:
	SBI  0xB,7
_0x148:
; 0000 02B5                      delay_ms(DELAY_TRG);
	RCALL SUBOPT_0x1B
; 0000 02B6                     }
; 0000 02B7 
; 0000 02B8 
; 0000 02B9            }
_0x146:
; 0000 02BA            break;
	RJMP _0xE5
; 0000 02BB 
; 0000 02BC            case 11: /////////////////////////
_0x140:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x149
; 0000 02BD            {
; 0000 02BE                 if (function[N_Out_ULN]==0)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x17
	CPI  R30,0
	BREQ PC+2
	RJMP _0x14A
; 0000 02BF                     {
; 0000 02C0                      ULN_2_5 = 1;
	SBI  0xB,6
; 0000 02C1                      delay_ms(DELAY_IMPULSE);
	RCALL SUBOPT_0x1A
; 0000 02C2                      ULN_2_5 = 0;
	CBI  0xB,6
; 0000 02C3                      }
; 0000 02C4                 if (function[N_Out_ULN]==1)
_0x14A:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x14F
; 0000 02C5                     {
; 0000 02C6                      ULN_2_5 = ~ULN_2_5;
	SBIS 0xB,6
	RJMP _0x150
	CBI  0xB,6
	RJMP _0x151
_0x150:
	SBI  0xB,6
_0x151:
; 0000 02C7                      delay_ms(DELAY_TRG);
	RCALL SUBOPT_0x1B
; 0000 02C8                     }
; 0000 02C9 
; 0000 02CA 
; 0000 02CB            }
_0x14F:
; 0000 02CC            break;
	RJMP _0xE5
; 0000 02CD 
; 0000 02CE            case 12: /////////////////////////
_0x149:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x152
; 0000 02CF            {
; 0000 02D0                 if (function[N_Out_ULN]==0)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x17
	CPI  R30,0
	BREQ PC+2
	RJMP _0x153
; 0000 02D1                     {
; 0000 02D2                      ULN_2_6 = 1;
	SBI  0xB,5
; 0000 02D3                      delay_ms(DELAY_IMPULSE);
	RCALL SUBOPT_0x1A
; 0000 02D4                      ULN_2_6 = 0;
	CBI  0xB,5
; 0000 02D5                      }
; 0000 02D6                 if (function[N_Out_ULN]==1)
_0x153:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x158
; 0000 02D7                     {
; 0000 02D8                      ULN_2_6 = ~ULN_2_6;
	SBIS 0xB,5
	RJMP _0x159
	CBI  0xB,5
	RJMP _0x15A
_0x159:
	SBI  0xB,5
_0x15A:
; 0000 02D9                      delay_ms(DELAY_TRG);
	RCALL SUBOPT_0x1B
; 0000 02DA                     }
; 0000 02DB 
; 0000 02DC 
; 0000 02DD            }
_0x158:
; 0000 02DE            break;
	RJMP _0xE5
; 0000 02DF 
; 0000 02E0            case 13: /////////////////////////
_0x152:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x164
; 0000 02E1            {
; 0000 02E2                 if (function[N_Out_ULN]==0)
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x17
	CPI  R30,0
	BREQ PC+2
	RJMP _0x15C
; 0000 02E3                     {
; 0000 02E4                      ULN_2_7 = 1;
	SBI  0x5,7
; 0000 02E5                      delay_ms(DELAY_IMPULSE);
	RCALL SUBOPT_0x1A
; 0000 02E6                      ULN_2_7 = 0;
	CBI  0x5,7
; 0000 02E7                      }
; 0000 02E8                 if (function[N_Out_ULN]==1)
_0x15C:
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x161
; 0000 02E9                     {
; 0000 02EA                      ULN_2_7 = ~ULN_2_7;
	SBIS 0x5,7
	RJMP _0x162
	CBI  0x5,7
	RJMP _0x163
_0x162:
	SBI  0x5,7
_0x163:
; 0000 02EB                      delay_ms(DELAY_TRG);
	RCALL SUBOPT_0x1B
; 0000 02EC                     }
; 0000 02ED 
; 0000 02EE 
; 0000 02EF            }
_0x161:
; 0000 02F0            break;
	RJMP _0xE5
; 0000 02F1 
; 0000 02F2            default: ; break;
_0x164:
; 0000 02F3 
; 0000 02F4            }
_0xE5:
; 0000 02F5 
; 0000 02F6            if (function[N_Out_ULN]==2)    //   "" 
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x165
; 0000 02F7            {
; 0000 02F8 
; 0000 02F9            if (function[0]==2) ULN_1_1 = 0;    //    0   
	LDS  R26,_function
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x166
	CBI  0xB,0
; 0000 02FA            if (function[1]==2) ULN_1_2 = 0;    //   
_0x166:
	__GETB2MN _function,1
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x169
	CBI  0x8,5
; 0000 02FB            if (function[2]==2) ULN_1_3 = 0;
_0x169:
	__GETB2MN _function,2
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x16C
	CBI  0x8,4
; 0000 02FC            if (function[3]==2) ULN_1_4 = 0;
_0x16C:
	__GETB2MN _function,3
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x16F
	CBI  0x8,3
; 0000 02FD            if (function[4]==2) ULN_1_5 = 0;
_0x16F:
	__GETB2MN _function,4
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x172
	CBI  0x8,2
; 0000 02FE            if (function[5]==2) ULN_1_6 = 0;
_0x172:
	__GETB2MN _function,5
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x175
	CBI  0x8,1
; 0000 02FF            if (function[6]==2) ULN_1_7 = 0;
_0x175:
	__GETB2MN _function,6
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x178
	CBI  0x8,0
; 0000 0300            if (function[7]==2) ULN_2_1 = 0;
_0x178:
	__GETB2MN _function,7
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x17B
	CBI  0x5,2
; 0000 0301            if (function[8]==2) ULN_2_2 = 0;
_0x17B:
	__GETB2MN _function,8
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x17E
	CBI  0x5,1
; 0000 0302            if (function[9]==2) ULN_2_3 = 0;
_0x17E:
	__GETB2MN _function,9
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x181
	CBI  0x5,0
; 0000 0303            if (function[10]==2) ULN_2_4 = 0;
_0x181:
	__GETB2MN _function,10
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x184
	CBI  0xB,7
; 0000 0304            if (function[11]==2) ULN_2_5 = 0;
_0x184:
	__GETB2MN _function,11
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x187
	CBI  0xB,6
; 0000 0305            if (function[12]==2) ULN_2_6 = 0;
_0x187:
	__GETB2MN _function,12
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x18A
	CBI  0xB,5
; 0000 0306            if (function[13]==2) ULN_2_7 = 0;
_0x18A:
	__GETB2MN _function,13
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x18D
	CBI  0x5,7
; 0000 0307 
; 0000 0308            switch (N_Out_ULN)
_0x18D:
	RCALL SUBOPT_0x19
; 0000 0309            {
; 0000 030A            case 0: ULN_1_1 = 1 ; break;         //    
	SBIW R30,0
	BREQ PC+2
	RJMP _0x193
	SBI  0xB,0
	RJMP _0x192
; 0000 030B            case 1: ULN_1_2 = 1; break;          //  
_0x193:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x196
	SBI  0x8,5
	RJMP _0x192
; 0000 030C            case 2: ULN_1_3 = 1; break;
_0x196:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x199
	SBI  0x8,4
	RJMP _0x192
; 0000 030D            case 3: ULN_1_4 = 1; break;
_0x199:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x19C
	SBI  0x8,3
	RJMP _0x192
; 0000 030E            case 4: ULN_1_5 = 1; break;
_0x19C:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x19F
	SBI  0x8,2
	RJMP _0x192
; 0000 030F            case 5: ULN_1_6 = 1; break;
_0x19F:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x1A2
	SBI  0x8,1
	RJMP _0x192
; 0000 0310            case 6: ULN_1_7 = 1; break;
_0x1A2:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x1A5
	SBI  0x8,0
	RJMP _0x192
; 0000 0311            case 7: ULN_2_1 = 1; break;
_0x1A5:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x1A8
	SBI  0x5,2
	RJMP _0x192
; 0000 0312            case 8: ULN_2_2 = 1; break;
_0x1A8:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x1AB
	SBI  0x5,1
	RJMP _0x192
; 0000 0313            case 9: ULN_2_3 = 1; break;
_0x1AB:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x1AE
	SBI  0x5,0
	RJMP _0x192
; 0000 0314            case 10: ULN_2_4 = 1; break;
_0x1AE:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x1B1
	SBI  0xB,7
	RJMP _0x192
; 0000 0315            case 11: ULN_2_5 = 1; break;
_0x1B1:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x1B4
	SBI  0xB,6
	RJMP _0x192
; 0000 0316            case 12: ULN_2_6 = 1; break;
_0x1B4:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x1B7
	SBI  0xB,5
	RJMP _0x192
; 0000 0317            case 13: ULN_2_7 = 1; break;
_0x1B7:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x1BD
	SBI  0x5,7
	RJMP _0x192
; 0000 0318            default:  break;
_0x1BD:
; 0000 0319            }
_0x192:
; 0000 031A 
; 0000 031B            }
; 0000 031C 
; 0000 031D            Execute = 0;
_0x165:
	CBI  0x1E,7
; 0000 031E         }
; 0000 031F       }
_0xE2:
	RJMP _0xDF
_0xE1:
; 0000 0320 }
_0x1C0:
	RJMP _0x1C0

	.DSEG
_T:
	.BYTE 0x2

	.ESEG
_e_address:
	.BYTE 0xE
_e_command:
	.BYTE 0xE
_e_function:
	.BYTE 0xE

	.DSEG
_address:
	.BYTE 0xE
_command:
	.BYTE 0xE
_function:
	.BYTE 0xE
_i_temp_address:
	.BYTE 0x1
_temp_command:
	.BYTE 0x1
_i_temp_command:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x0:
	SBI  0xB,3
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CBI  0xB,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	LD   R30,Y
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	MOV  R26,R12
	LDI  R27,0
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x4:
	SBI  0xB,3
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CBI  0xB,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x6:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	LDI  R26,0
	SBIC 0x3,6
	LDI  R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x8:
	MOV  R26,R11
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x9:
	MOV  R30,R11
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xA:
	SUBI R30,LOW(-_command)
	SBCI R31,HIGH(-_command)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xB:
	SUBI R30,LOW(-_address)
	SBCI R31,HIGH(-_address)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 35 TIMES, CODE SIZE REDUCTION:32 WORDS
SUBOPT_0xC:
	SUBI R30,LOW(-_function)
	SBCI R31,HIGH(-_function)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xD:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:34 WORDS
SUBOPT_0xE:
	LDS  R26,_T
	LDS  R27,_T+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	STS  _temp_command,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	LDI  R30,LOW(32)
	CP   R30,R8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	LSL  R30
	SUBI R30,-LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x12:
	CBI  0x1E,3
	CBI  0x1E,4
	CBI  0x1E,5
	CBI  0x1E,6
	CBI  0x1E,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x13:
	LDI  R30,LOW(0)
	STS  _T,R30
	STS  _T+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x14:
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	CPI  R26,LOW(0xFF)
	LDI  R30,HIGH(0xFF)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:38 WORDS
SUBOPT_0x15:
	MOV  R30,R4
	LDI  R31,0
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x16:
	RCALL SUBOPT_0xC
	LD   R26,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x17:
	RCALL SUBOPT_0xC
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	RCALL __EEPROMRDB
	MOVW R26,R0
	ST   X,R30
	RJMP SUBOPT_0x9

;OPTIMIZER ADDED SUBROUTINE, CALLED 31 TIMES, CODE SIZE REDUCTION:88 WORDS
SUBOPT_0x19:
	MOV  R30,R3
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:50 WORDS
SUBOPT_0x1A:
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:50 WORDS
SUBOPT_0x1B:
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

;END OF CODE MARKER
__END_OF_CODE:
