/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : TSOP
Version : 1.0
Date    : 06.05.2012
Author  : Vychegzhanin Sergey 
Company : Home

Chip type               : ATmega48PA
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 128
*****************************************************/

#include <mega48a.h>
#include <delay.h>

// Declare your global variables here

#define ULN_1_7     PORTC.0   //    
#define ULN_1_6     PORTC.1
#define ULN_1_5     PORTC.2
#define ULN_1_4     PORTC.3
#define ULN_1_3     PORTC.4
#define ULN_1_2     PORTC.5
#define ULN_1_1     PORTD.0

#define ULN_2_7     PORTB.7
#define ULN_2_6     PORTD.5
#define ULN_2_5     PORTD.6
#define ULN_2_4     PORTD.7
#define ULN_2_3     PORTB.0
#define ULN_2_2     PORTB.1
#define ULN_2_1     PORTB.2

#define LED1        PORTD.1   //    
#define LED2        PORTD.3   // LED1 - , LED2 - 

#define B1          PIND.4    //     
#define B2          PINB.6

#define TSOP        PIND.2    //    TSOP

#define DELAY_IMPULSE   40     //  
#define DELAY_TRG       500    //   ""

unsigned char N_Out = 0;        //      1 - 14
unsigned char N_Out_ULN = 0;    //      1 - 14

int Reg_Out = 0;    //   

unsigned char count = 0;    //  

bit Mode = 0;   // 0 -  
                // 1 -   

bit Correct = 0;    // 1 -   
                    // 0 -   
                    
bit Permit = 0;     // 0 -  
                    // 1 -  
                    
bit Success = 0;    // 0 -   
                    // 1 -                      
                    
bit Wait_Stop = 0;  // 0 -     
                    // 1 -  

bit Stop = 0;       // 0 - -  
                    // 1 - - 
                    
bit Repeat = 0;     // 0 -    
                    // 1 -                       


bit Execute = 0;    // 0 -   
                    // 1 -    

                    
unsigned char temp1, temp2, temp3, j, n, temp_ULN;  //  

int i;
int T;  //       
        //         TSOP'a 

eeprom unsigned char e_address[14];      //    
eeprom unsigned char e_command[14];  //    
eeprom unsigned char e_function[14];  //     

unsigned char address[14];
unsigned char command[14];
unsigned char function[14]; // 0 - 
                            // 1 - 
                            // 2 -     (     )

unsigned char temp_address;     //  
unsigned char i_temp_address;   //   
unsigned char temp_command;     //       
unsigned char i_temp_command;   //   



void ULN_Disable (void) //  0   
{
  
        ULN_1_1 = 0;   
        ULN_1_2 = 0; 
        ULN_1_3 = 0;
        ULN_1_4 = 0;
        ULN_1_5 = 0;
        ULN_1_6 = 0;
        ULN_1_7 = 0;
        ULN_2_1 = 0;
        ULN_2_2 = 0;
        ULN_2_3 = 0;
        ULN_2_4 = 0;
        ULN_2_5 = 0;
        ULN_2_6 = 0;
        ULN_2_7 = 0;

}

void Flash_light (unsigned char m)   //   n- 
{  
    if (m<=7)
        {
          for (j=0; j<m; j++)
            {
                LED2=1;
                delay_ms(300);
                LED2=0;
                delay_ms(300);
            }    
        }
    else if (m<=14)
        {
            for (j=0; j<(m-7); j++)
            {
                LED2=1;
                delay_ms(50);
                LED2=0;
                delay_ms(50);
                LED2=1;
                delay_ms(50);
                LED2=0;
                delay_ms(300);
            }  
        }  
        else
        
        {
            for (j=0; j<(m-14); j++)
            {
                LED2=1;
                delay_ms(50);
                
                LED2=0;
                delay_ms(50);
                
                LED2=1;
                delay_ms(300); 
                
                LED2=0;
                delay_ms(50); 
                
                LED2=1;
                delay_ms(50); 
                
                LED2=0;
                delay_ms(300);
            } 
        }  
}


interrupt [TIM2_COMPA] void timer2_comp_a(void)
{
  if (B1==0&B2==1) {temp1++;}     //    
 else {if (temp1>2) temp1--;}  //   ,   temp
 
  if (B2==0&&B1==1) {temp2++;}     //    
 else {if (temp2>2) temp2--;}  //   ,   temp 
 
 if (B2==0&&B1==0) {temp3++;}     //    
 else {if (temp3>2) temp3--;}  //   ,   temp
 

 
 if (temp1>200&&temp2<10)   //   
    {
      Mode=~Mode;  
      
      if (Mode) LED1=1;
      else LED1=0; 
      
      N_Out=0;
      
      temp1=0;  
     
      ULN_Disable(); //    0
      
     }
  
 if (temp2>100&&temp1<10) 
    {
      if (Mode==1)  //    
         {
            if (N_Out<=13) 
                {
                N_Out++;
                
                Flash_light(N_Out);   //  N_out  LED2
                }
            else N_Out=0;    
         }
      
         
      temp2=0;
      }
  
  if (temp3>250)            //     B1  B2   EEPROM
    {
      for (n=0;n<14;n++)
      
      {
        e_command[n]=0xFF;
        e_address[n]=0xFF;
        e_function[n]=0xFF;
        command[n]=0xFF;
        address[n]=0xFF;
        function[n]=0xFF;
        
        ULN_Disable(); //    0
      }
      
      Flash_light(16);
      temp3=0;   
     }
  
}


interrupt [EXT_INT0] void ext_int0_isr(void)  //       TSOP'
{
 TCNT0=0x00;  //  
 TCCR0B=0x02; //  
 
 if ((T>3)&&(T<6)&&Permit)            //  0,768...1,536  -  0
    {   count++;
    
        if (count<=8) temp_address = temp_address<<1;                   //    
        if (count>=9 && count<=16) i_temp_address = i_temp_address<<1;  //        
        if (count>=17 && count<=24) temp_command = temp_command<<1;     //         
        if (count>=25 && count<=32) i_temp_command = i_temp_command<<1; //                               
        if (count==32)
            {
             Permit=0;
             Success=1;
             }  
    }
    
 if ((T>7)&&(T<11)&&Permit)           //  1,782...2,816  -  1
    {   count++;
    
        if (count<=8) temp_address = (temp_address<<1) + 1;                     //                    
        if (count>=9 && count<=16) i_temp_address = (i_temp_address<<1) + 1;    //        
        if (count>=17 && count<=24) temp_command = (temp_command<<1) + 1;       //      
        if (count>=25 && count<=32) i_temp_command = (i_temp_command<<1) + 1;   //                               
        if (count==32)
            {
             Permit=0;
             Success=1;
             }  
    }
     
 if ((T>35)&&(T<47)&&Wait_Stop)       //  8,96...12,032  -   stop
    {
      Stop = 1;
      }
 
 if ((T>50)&&(T<55))                  //  12,8...14,08  -   start
    {
      temp_address = 0;
      i_temp_address = 0;   
      temp_command = 0;       
      i_temp_command = 0;
      
      count=0;
      Permit = 1;
      Success = 0;
      Wait_Stop = 0;
      Stop = 0;
      Repeat = 0; 
      Correct = 0;
          
    }
    
 if ((T>150)&&(T<160)&&Success)       //  38...40,96  -  wait_stop
    {
       Wait_Stop = 1;
    }   
    
 if ((T>350)&&(T<420)&&Correct)       //  89,6...107,52  -  repeat
    {
        Repeat = 1;
    
    
    }

  T=0;
 
  if ((Success == 1)&&(temp_address + i_temp_address == 0xff)&&(temp_command + i_temp_command == 0xff)) 
 
  //    
  //    
    {   
        Correct = 1;
    }
    
    
  if ((Mode==1)&&(Stop==1)&&(Correct==1)&&(Success==1))  //     
    {
        TCCR0B=0x00;
        
        if (N_Out>0)
        {
        address[N_Out-1] = temp_address;
        command[N_Out-1]= temp_command;
        
        e_address[N_Out-1] = address[N_Out-1];
        e_command[N_Out-1]= command[N_Out-1];
        
        if (function[N_Out-1]<3) function[N_Out-1] += 1;  //     EEPROM - 0xFF 
        else function[N_Out-1] = 0 ;                      //      0x00
    
        e_function[N_Out-1]= function[N_Out-1];
            
        }    
        
        Flash_light(15);

        Permit = 0;
        Success = 0;
        Wait_Stop = 0;
        Stop = 0;
        Repeat = 0;
        Correct = 0;
    
    }  
    
  if ((Mode==0)&&(Success==1||Repeat==1)&&(Stop==1)&&(Correct==1))  //     
    {    TCCR0B=0x00; 
        
                for (n=0; n<14; n++)       //     
                    {
                      if ((temp_command == command[n])&&(temp_address == address[n]))
                            {
                             N_Out_ULN = n;
                             Execute = 1;
                             n=14;
                            }
                    }

         Success = 0;
         Repeat = 0;
    }   
}


 interrupt [TIM0_OVF] void timer0_ovf_isr(void)    //   256 
{
TCNT0=0x00;
if (T>450)
    {
        count = 0; //   ,   -
        Permit = 0;
        Success = 0;
        Correct = 0;
        Repeat = 0;
        Stop = 0;
        T = 0;
        temp_command = 0x00; 
        temp_address = 0x00;
        TCCR0B=0x00;
        }
else T++;
}

void main(void)
{

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

//  
{
PORTB=0x40;
DDRB=0x87;
PORTC=0x00;
DDRC=0x3F;
PORTD=0x14;
DDRD=0xEB;

// Timer/Counter 0 initialization
TCCR0A=0x00;
TCCR0B=0x02;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
TCCR1A=0x00;
TCCR1B=0x00;
//TCCR1B=0x04;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;  
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
ASSR=0x00;
TCCR2A=0x82;
TCCR2B=0x05;
TCNT2=0x00;
OCR2A=0xFF;
OCR2B=0x00;

// External Interrupt(s) initialization
EICRA=0x02;
EIMSK=0x01;
EIFR=0x01;
PCICR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x01;

// Timer/Counter 1 Interrupt(s) initialization
TIMSK1=0x00;

// Timer/Counter 2 Interrupt(s) initialization
TIMSK2=0x02;
TIFR0=0x02;
TIFR2=0x02;

// USART initialization
// USART disabled
UCSR0B=0x00;

// Analog Comparator initialization
ACSR=0x80;
ADCSRB=0x00;
DIDR1=0x00;

// ADC initialization
ADCSRA=0x00;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;
 }



for (n=0;n<14;n++)      //     EEPROM'

{
  address[n] = e_address[n];       
  command[n] = e_command[n];
  function[n] = e_function[n];
}


#asm ("sei")  


while (1)        //      
      {
        if (Execute==1)     //      
                            //    
        {
           Reg_Out=0;
           temp_ULN = 0x00;
           
           
           switch (N_Out_ULN)
           {  
          
            case 0:  /////////////////////////
           {
                if (function[N_Out_ULN]==0)
                    {
                     ULN_1_1 = 1;
                     delay_ms(DELAY_IMPULSE);
                     ULN_1_1 = 0;
                     } 
                if (function[N_Out_ULN]==1) 
                    {
                     ULN_1_1 = ~ULN_1_1;
                     delay_ms(DELAY_TRG);
                    }
               
           }
           break;
           
           case 1:   /////////////////////////
           {
                if (function[N_Out_ULN]==0)
                    {
                     ULN_1_2 = 1;
                     delay_ms(DELAY_IMPULSE);
                     ULN_1_2 = 0;
                     } 
                if (function[N_Out_ULN]==1) 
                    {
                     ULN_1_2 = ~ULN_1_2;
                     delay_ms(DELAY_TRG);
                    }
                
           }
           break;
           
           case 2:  /////////////////////////
           {
                if (function[N_Out_ULN]==0)
                    {
                     ULN_1_3 = 1;
                     delay_ms(DELAY_IMPULSE);
                     ULN_1_3 = 0;
                     } 
                if (function[N_Out_ULN]==1) 
                    {
                     ULN_1_3 = ~ULN_1_3;
                     delay_ms(DELAY_TRG);
                    }
                    
           }
           break;
           
           case 3:  /////////////////////////
           {
                if (function[N_Out_ULN]==0)
                    {
                     ULN_1_4 = 1;
                     delay_ms(DELAY_IMPULSE);
                     ULN_1_4 = 0;
                     } 
                if (function[N_Out_ULN]==1) 
                    {
                     ULN_1_4 = ~ULN_1_4;
                     delay_ms(DELAY_TRG);
                    }
               
           }
           break;
           
           case 4: ///////////////////////// 
           {
                if (function[N_Out_ULN]==0)
                    {
                     ULN_1_5 = 1;
                     delay_ms(DELAY_IMPULSE);
                     ULN_1_5 = 0;
                     } 
                if (function[N_Out_ULN]==1) 
                    {
                     ULN_1_5 = ~ULN_1_5;
                     delay_ms(DELAY_TRG);
                    }
                   
           }
           break;

           case 5:  /////////////////////////  
           {
                if (function[N_Out_ULN]==0)
                    {
                     ULN_1_6 = 1;
                     delay_ms(DELAY_IMPULSE);
                     ULN_1_6 = 0;
                     } 
                if (function[N_Out_ULN]==1) 
                    {
                     ULN_1_6 = ~ULN_1_6;
                     delay_ms(DELAY_TRG);
                    }
                    
               
           }
           break;       
           
           case 6:  ///////////////////////// 
           {
                if (function[N_Out_ULN]==0)
                    {
                     ULN_1_7 = 1;
                     delay_ms(DELAY_IMPULSE);
                     ULN_1_7 = 0;
                     } 
                if (function[N_Out_ULN]==1) 
                    {
                     ULN_1_7 = ~ULN_1_7;
                     delay_ms(DELAY_TRG);
                    }
                    
               
           }
           break;
           
           case 7: ///////////////////////// 
           {
                if (function[N_Out_ULN]==0)
                    {
                     ULN_2_1 = 1;
                     delay_ms(DELAY_IMPULSE);
                     ULN_2_1 = 0;
                     } 
                if (function[N_Out_ULN]==1) 
                    {
                     ULN_2_1 = ~ULN_2_1;
                     delay_ms(DELAY_TRG);
                    }
                    
               
           }
           break;    
            
           case 8: /////////////////////////  
           {
                if (function[N_Out_ULN]==0)
                    {
                     ULN_2_2 = 1;
                     delay_ms(DELAY_IMPULSE);
                     ULN_2_2 = 0;
                     } 
                if (function[N_Out_ULN]==1) 
                    {
                     ULN_2_2 = ~ULN_2_2;
                     delay_ms(DELAY_TRG);
                    }
                    
                
           }
           break;       
           
           case 9: /////////////////////////
           {
                if (function[N_Out_ULN]==0)
                    {
                     ULN_2_3 = 1;
                     delay_ms(DELAY_IMPULSE);
                     ULN_2_3 = 0;
                     } 
                if (function[N_Out_ULN]==1) 
                    {
                     ULN_2_3 = ~ULN_2_3;
                     delay_ms(DELAY_TRG);
                    }
                    
                
           }
           break;
             
           case 10: /////////////////////////
           {
                if (function[N_Out_ULN]==0)
                    {
                     ULN_2_4 = 1;
                     delay_ms(DELAY_IMPULSE);
                     ULN_2_4 = 0;
                     } 
                if (function[N_Out_ULN]==1) 
                    {
                     ULN_2_4 = ~ULN_2_4;
                     delay_ms(DELAY_TRG);
                    }
                    
               
           }
           break;
           
           case 11: /////////////////////////
           {
                if (function[N_Out_ULN]==0)
                    {
                     ULN_2_5 = 1;
                     delay_ms(DELAY_IMPULSE);
                     ULN_2_5 = 0;
                     } 
                if (function[N_Out_ULN]==1) 
                    {
                     ULN_2_5 = ~ULN_2_5;
                     delay_ms(DELAY_TRG);
                    }
                    
              
           }
           break;
           
           case 12: /////////////////////////
           {
                if (function[N_Out_ULN]==0)
                    {
                     ULN_2_6 = 1;
                     delay_ms(DELAY_IMPULSE);
                     ULN_2_6 = 0;
                     } 
                if (function[N_Out_ULN]==1) 
                    {
                     ULN_2_6 = ~ULN_2_6;
                     delay_ms(DELAY_TRG);
                    }
                    
               
           }
           break;
           
           case 13: /////////////////////////
           {
                if (function[N_Out_ULN]==0)
                    {
                     ULN_2_7 = 1;
                     delay_ms(DELAY_IMPULSE);
                     ULN_2_7 = 0;
                     } 
                if (function[N_Out_ULN]==1) 
                    {
                     ULN_2_7 = ~ULN_2_7;
                     delay_ms(DELAY_TRG);
                    }
                    
               
           }
           break;
           
           default: ; break;
           
           }
                    
           if (function[N_Out_ULN]==2)    //   "" 
           {
    
           if (function[0]==2) ULN_1_1 = 0;    //    0   
           if (function[1]==2) ULN_1_2 = 0;    //   
           if (function[2]==2) ULN_1_3 = 0; 
           if (function[3]==2) ULN_1_4 = 0;
           if (function[4]==2) ULN_1_5 = 0;
           if (function[5]==2) ULN_1_6 = 0;
           if (function[6]==2) ULN_1_7 = 0;
           if (function[7]==2) ULN_2_1 = 0;
           if (function[8]==2) ULN_2_2 = 0;
           if (function[9]==2) ULN_2_3 = 0;
           if (function[10]==2) ULN_2_4 = 0;
           if (function[11]==2) ULN_2_5 = 0;
           if (function[12]==2) ULN_2_6 = 0;
           if (function[13]==2) ULN_2_7 = 0;
           
           switch (N_Out_ULN)
           {
           case 0: ULN_1_1 = 1 ; break;         //    
           case 1: ULN_1_2 = 1; break;          //  
           case 2: ULN_1_3 = 1; break;
           case 3: ULN_1_4 = 1; break;
           case 4: ULN_1_5 = 1; break;
           case 5: ULN_1_6 = 1; break;
           case 6: ULN_1_7 = 1; break;
           case 7: ULN_2_1 = 1; break;
           case 8: ULN_2_2 = 1; break;
           case 9: ULN_2_3 = 1; break;
           case 10: ULN_2_4 = 1; break;
           case 11: ULN_2_5 = 1; break;
           case 12: ULN_2_6 = 1; break;
           case 13: ULN_2_7 = 1; break;
           default:  break;
           }
           
           }
           
           Execute = 0;
        }
      }
}
